//+------------------------------------------------------------------+
//|                                                ADXVMA6_16bar.mq4 |                                     
//+------------------------------------------------------------------+
//Revision history; 
//FantailVMA1: Modified version of VarMA_v1.1.mq4 and Fantail.tpl
//FantailVMA1.mq4 is intended to used by adding the template FantailVMA1.tpl to the chart. 10 Sept 2007.
//FantailVMA2 & Fantail2.tpl: Turbo version attempt, 17 Sept 2007. Malfunctioned at live end of chart.
//FantailVMA3 & Fantail3.tpl: Bug fix, work-around added to keep iMAOnArray() from malfunctioning.
//The first yellow ema line MA1 periods=2, was deleted in version 3.
//FantailVMA4 & Fantail4.tpl: Simpler input, bug fix, speed improvement, 3 vma lines, 24 Sept 2007.
//FantailVMA4 & 4Turbo used faulty smoothing that failed on live charts.
//FantailVMA5Turbo, live bar bug fix, user settings added. Still live bar problems.
//ADXVMA5Line1-3 back to using arrays, so its one vma line per indicator.
//ADXVMA6Test1 for testing on 5min vs vma1 and Bemac, more settings and ema100 line.

#property indicator_chart_window
#property indicator_buffers   1
#property indicator_color1    Black
#property indicator_width1    2 
//#property indicator_color2    Aqua
//#property indicator_width2    2 
//---- input parameters
extern string  TimeFrame      = "Current time frame";
extern int     ADX_Bars=16;
//extern double  WeightDM=4.0;
//extern double  WeightDI=4.0;
//extern double  WeightDX=4.0;
//extern int     VI_0.VIsq_1.VIsqroot_2=0;
//extern double  VImax=1;
//extern double  zeroVIbelow=0;
//extern double  ChandeEMA=4.0;
//extern int     EMA100=100;
//---- buffers
double MA[];
double EMA[];
double PDM[];//Not displayed
double MDM[];//Not displayed
double PDI[];//Not displayed
double MDI[];//Not displayed
double Out[];//Not displayed

string indicatorFileName;
bool   returnBars;
int    timeFrame;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
   IndicatorBuffers(7);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,MA);
//   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,EMA);   
   SetIndexBuffer(2,PDM);
   SetIndexBuffer(3,MDM);   
   SetIndexBuffer(4,PDI);
   SetIndexBuffer(5,MDI); 
   SetIndexBuffer(6,Out);
   SetIndexLabel(0,"ADXVMA6_16bar");
//   SetIndexLabel(1,"ADXVMA6Test2ema");
   //----
   SetIndexDrawBegin(0,4+ADX_Bars);
//   SetIndexDrawBegin(1,4+ADX_Bars);      
//--------- Safety overrides on user settings
   if (ADX_Bars<2)ADX_Bars=2;
/*   
   if (WeightDM<1.0)WeightDM=1.0;
   if (WeightDI<1.0)WeightDI=1.0;
   if (WeightDX<1.0)WeightDX=1.0;
   if (VI_0.VIsq_1.VIsqroot_2<0)VI_0.VIsq_1.VIsqroot_2=0;
   if (VI_0.VIsq_1.VIsqroot_2>2)VI_0.VIsq_1.VIsqroot_2=0;      
   if (VImax<0.1)VImax=1.0;
   if (zeroVIbelow<0)zeroVIbelow=0;
   if (zeroVIbelow>1)zeroVIbelow=0;
   if (ChandeEMA<1.0)ChandeEMA=1.0;
   if (EMA100<1)EMA100=1;
*/
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
   
   IndicatorShortName(timeFrameToString(timeFrame)+"  ADXVMA6_16bar");
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { MA[0] = limit+1; return(0); }
   
            if (timeFrame!=Period())
            {
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                   int y = iBarShift(NULL,timeFrame,Time[i]);             
                      MA[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",ADX_Bars,0,y);
               }
               return(0);
            }
   int    j;
   double TR,DI_Diff, DI_Sum, DI_Factor, VI, diff, HHV, LLV;
   double WeightDM=ADX_Bars, WeightDI=ADX_Bars, WeightDX=ADX_Bars,ChandeEMA=ADX_Bars; 

//---- 
     
   if (counted_bars<0) return(-1);  //MT4 error exit.

   for(i=Bars-counted_bars-1;i>Bars-4-ADX_Bars;i--) //Fill the oldest bars with safe data for any averaging.
   {
   MA[i]=Close[i];    
   PDM[i]=0;
   MDM[i]=0;
   PDI[i]=0;
   MDI[i]=0;
   Out[i]=0;
   }
   
   for(i=i; i>=0; i--) //Main loop begins after history bars filled.
   {     
   PDM[i]=0;
   MDM[i]=0;
   if(Close[i]>Close[i+1])PDM[i]=Close[i]-Close[i+1];//This array is not displayed.
   else MDM[i]=Close[i+1]-Close[i];//This array is not displayed.

   PDM[i]=((WeightDM-1)*PDM[i+1] + PDM[i])/WeightDM;//ema.
   MDM[i]=((WeightDM-1)*MDM[i+1] + MDM[i])/WeightDM;//ema.

   TR=PDM[i]+MDM[i];

   if (TR>0) {PDI[i]=PDM[i]/TR; MDI[i]=MDM[i]/TR;}//Avoid division by zero. Minimum step size is one unnormalized price pip.
   else {PDI[i]=0; MDI[i]=0;}
   
   PDI[i]=((WeightDI-1)*PDI[i+1] + PDI[i])/WeightDI;//ema.
   MDI[i]=((WeightDI-1)*MDI[i+1] + MDI[i])/WeightDI;//ema.
   DI_Diff=PDI[i]-MDI[i];  
   if (DI_Diff<0) DI_Diff= -DI_Diff;//Only positive momentum signals are used.
   DI_Sum=PDI[i]+MDI[i];
   DI_Factor=0;//Zero case, DI_Diff will also be zero when DI_Sum is zero.
   if (DI_Sum>0) Out[i]=DI_Diff/DI_Sum;//Factional, near zero when PDM==MDM (horizonal), near 1 for laddering.
   else Out[i]=0;
   Out[i]=((WeightDX-1)*Out[i+1] + Out[i])/WeightDX;

   if (Out[i]>Out[i+1]){HHV=Out[i];LLV=Out[i+1];}
   else {HHV=Out[i+1];LLV=Out[i];}
   for(j=1;j<ADX_Bars;j++)
   {
   if(Out[i+j+1]>HHV)HHV=Out[i+j+1];
   if(Out[i+j+1]<LLV)LLV=Out[i+j+1];
   }


   diff = HHV - LLV;//Veriable reference scale, adapts to recent activity level, unnormalized.
   VI=0;//Zero case. This fixes the output at its historical level. 
   if (diff>0) VI=(Out[i]-LLV)/diff;//Normalized, 0-1 scale.
   
//   if (VI_0.VIsq_1.VIsqroot_2==1)VI*=VI;
//   if (VI_0.VIsq_1.VIsqroot_2==2)VI=MathSqrt(VI);
//   if (VI>VImax)VI=VImax;//Used by Bemac with VImax=0.4, still used in vma1 and affects 5min trend definition.
                        //All the ema weight settings, including Chande, affect 5 min trend definition.
//   if (VI<=zeroVIbelow)VI=0;                    
                        
   MA[i]=((ChandeEMA-VI)*MA[i+1]+VI*Close[i])/ChandeEMA;//Chande VMA formula with ema built in.
    
   }
   //According to Metaquotes, iMAOnArray has a "known issue" and must be in its own loop.
   //They don't say where in the sequence of loops it has to be to keep for crashing.
/*   
   if(counted_bars==0) limit=Bars-1;
   if(counted_bars>0) limit=Bars-counted_bars;
   limit--;//Helps to compensate for missed ticks on live charts by rewritting recent bars.

   for(j=limit; j>=0; j--) EMA[j] = iMAOnArray(MA,0,EMA100,0,1,j);//secondary ema line.
*/  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}
           

